routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();

Route::get('/', 'RoomController@index')->name('rooms.index');

Route::get('/rooms/reservations', 'ReservationController@show')
    ->name('reservations.show');

Route::resource('rooms', 'RoomController')
    ->parameters([
        'room' => '[0-9]+',
    ])
    ->except(['edit', 'update', 'delete']);

Route::post('/rooms/{room}/reservations', 'ReservationController@store')
    ->where('room', '[0-9]+')
    ->name('reservations.store');

app/Address.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Address extends Model
{
    protected $fillable = [
        'numero', 'rue', 'cp', 'ville', 'pays'
    ];

    function rooms() {
        return $this->hasOne( Room::class );
    }
}

app/Equipment.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Equipment extends Model
{
    function rooms() {
        return $this->belongsToMany( Room::class );
    }
}

app/Reservation.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Reservation extends Model
{
    protected $fillable = [
        'user_id', 'room_id', 'date_start', 'date_end'
    ];

    function user() {
        return $this->belongsTo( User::class );
    }

    function room() {
        return $this->belongsTo( Room::class );
    }
}

app/Role.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Role extends Model
{
    function user() {
        return $this->hasMany( User::class );
    }
}

app/Room.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Room extends Model
{
    protected $fillable = [
        'title', 'size', 'price', 'bedding', 'description', 'type_id', 'address_id', 'user_id'
    ];

    function user() {
        return $this->belongsTo( User::class );
    }

    function address() {
        return $this->belongsTo( Address::class );
    }

    function type() {
        return $this->belongsTo(Type::class );
    }

    function reserved() {
        return $this->hasMany( Reservation::class );
    }

    function equipments() {
        return $this->belongsToMany(Equipment::class );
    }

    function addEquipments(array $equipment) {
        $this->equipments()->attach($equipment);
    }

    function hasEquipment( $id ) {
        return $this->equipments->contains($id);
    }

}

app/Type.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Type extends Model
{
    function rooms() {
        return $this->hasMany( Room::class );
    }
}

app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password', 'role_id'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    function rooms() {
        return $this->hasMany( Room::class );
    }
    function reserved() {
        return $this->hasMany( Reservation::class );
    }

}

app/Http/Controllers/AddressController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class AddressController extends Controller
{
    public function store(Request $request, Address $address)
    {
        $fields = $request->validate([
            'numero' => 'nullable',
            'rue' => 'nullable',
            'cp' => 'nullable',
            'ville' => 'required',
            'pays' => 'required'
        ]);
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        return view('home');
    }
}

app/Http/Controllers/ReservationController.php
<?php

namespace App\Http\Controllers;

use App\Reservation;
use App\Room;
use Auth;
use Illuminate\Http\Request;

class ReservationController extends Controller
{

    /**
     * Display the specified resource.
     *
     * @param  \App\Reservation  $reservation
     * @return \Illuminate\Http\Response
     */
    public function index(Reservation $reservation)
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request, Room $room)
    {
        $fields = $request->validate([
            'date_start' => 'required',
            'date_end' => 'required',
        ]);

        $fields['user_id'] = Auth::user()->id;
        $fields['room_id'] = $room->id;

        $reservation = Reservation::create( $fields );

        return redirect(route('reservations.show'));
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Reservation  $reservation
     * @return \Illuminate\Http\Response
     */
    public function show()
    {
        $reservations = Auth::user()->reserved;

        return view('reservations.show', compact('reservations'));
    }


}

app/Http/Controllers/RoomController.php
<?php

namespace App\Http\Controllers;

use App\Equipment;
use App\Room;
use App\Type;
use App\Address;
use Auth;
use Illuminate\Http\Request;

class RoomController extends Controller
{
    function __construct()
    {
        $this->middleware('auth', ['except' => ['index', 'show']]);
        $this->middleware('check.announcer', ['only' => ['create', 'store']]);
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $rooms = Room::all();
        return view('rooms.index', compact('rooms'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $types = Type::all();
        $equipments = Equipment::all();
        return view('rooms.create', compact('types', 'equipments'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $fields = $request->validate([
            'title' => 'required|max:100',
            'size' => 'required',
            'price' => 'required',
            'bedding' => 'required',
            'numero' => 'nullable',
            'rue' => 'nullable',
            'cp' => 'nullable',
            'ville' => 'required',
            'pays' => 'required',
            'description' => 'nullable',
            'type_id' => 'required',
            'equipments' => 'nullable',
        ]);

        $address = Address::create( $fields );

        $fields['user_id'] = Auth::user()->id;
        $fields['address_id'] = $address->id;

        $room = Room::create( $fields );
        $room->addEquipments( $fields['equipments'] );

        return redirect( route('rooms.show', $room) );

    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Rooms  $rooms
     * @return \Illuminate\Http\Response
     */
    public function show(Room $room)
    {
        $equips = Equipment::all();
        return view('rooms.show', compact('room', 'equips'));
    }

}

resources/views/errors.blade.php
@if ( $errors->any() )

    <div style="color:red">
        <ul>
            @foreach ($errors->all() as $error)
                <li> {{ $error }} </li>
            @endforeach
        </ul>
    </div>

@endif

resources/views/home.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">Dashboard</div>

                <div class="card-body">
                    @if (session('status'))
                        <div class="alert alert-success" role="alert">
                            {{ session('status') }}
                        </div>
                    @endif

                    You are logged in!
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/layouts/app.blade.php
<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name') }}</title>

    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}" defer></script>

    <!-- Fonts -->
    <link rel="dns-prefetch" href="//fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css?family=Nunito" rel="stylesheet" type="text/css">

    <!-- Styles -->
    <link href="{{ asset('css/app.css') }}" rel="stylesheet">
    <style>
        .form-control2 {
            display: block;
            height: calc(2.19rem + 2px);
            padding: .375rem .75rem;
            font-size: .9rem;
            line-height: 1.6;
            color: #495057;
            background-color: #fff;
            background-clip: padding-box;
            border: 1px solid #ced4da;
            border-radius: .25rem;
            transition: border-color .15s ease-in-out,box-shadow .15s ease-in-out;
        }
    </style>
</head>
<body>
<div id="app">
    <nav class="navbar navbar-expand-md navbar-light navbar-laravel">
        <div class="container">
            <a class="navbar-brand" href="{{ url('/') }}">
                {{ config('app.name') }}
            </a>
            <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="{{ __('Toggle navigation') }}">
                <span class="navbar-toggler-icon"></span>
            </button>

            @auth
                @if(Auth::user()->role_id == 1)
                    <a href="{{ route('rooms.create') }}">Ajouter un article</a>
                @endif
            @endauth


            @auth
                <a href="{{ route('reservations.show') }}">Voir mes réservations</a>
            @endauth

            <div class="collapse navbar-collapse" id="navbarSupportedContent">
                <!-- Left Side Of Navbar -->
                <ul class="navbar-nav mr-auto">

                </ul>

                <!-- Right Side Of Navbar -->
                <ul class="navbar-nav ml-auto">
                    <!-- Authentication Links -->
                    @guest
                        <li class="nav-item">
                            <a class="nav-link" href="{{ route('login') }}">{{ __('Login') }}</a>
                        </li>
                        @if (Route::has('register'))
                            <li class="nav-item">
                                <a class="nav-link" href="{{ route('register') }}">{{ __('Register') }}</a>
                            </li>
                        @endif
                    @else
                        <li class="nav-item dropdown">
                            <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                {{ Auth::user()->name }} <span class="caret"></span>
                            </a>

                            <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdown">
                                <a class="dropdown-item" href="{{ route('logout') }}"
                                   onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                    {{ __('Logout') }}
                                </a>

                                <form id="logout-form" action="{{ route('logout') }}" method="POST" style="display: none;">
                                    @csrf
                                </form>
                            </div>
                        </li>
                    @endguest
                </ul>
            </div>
        </div>
    </nav>

    <main class="py-4">
        <div class="container">
            @yield('header')
            <br>
            @yield('content')
        </div>

    </main>
</div>
</body>
</html>

resources/views/reservations/show.blade.php
@extends('layouts.app')

@section('title', 'Réservations')

@section('header')
    <h1>Vos réservations</h1>
@endsection

@section('content')
Vos prochaines vacances :
<table class="table">
    <thead class="thead-dark">
    <tr>
        <th scope="col">Location</th>
        <th scope="col">Ville</th>
        <th scope="col">Pays</th>
        <th scope="col">Date de début</th>
        <th scope="col">Date de fin</th>
    </tr>
    </thead>

    <tbody>
        @foreach($reservations as $reservation)
            <tr>
                <td>{{ $reservation->room->title }}</td>
                <td>{{ $reservation->room->address->ville }}</td>
                <td>{{ $reservation->room->address->pays }}</td>
                <td>{{ $reservation->date_start }}</td>
                <td>{{ $reservation->date_end }}</td>
            </tr>
        @endforeach
    </tbody>
</table>

@if(Auth::user()->role_id == 1)
    Vos chambres réservées :
    <table class="table">
        <thead class="thead-dark">
            <tr>
                <th scope="col">Location</th>
                <th scope="col">Ville</th>
                <th scope="col">Pays</th>
                <th scope="col">Date de début</th>
                <th scope="col">Date de fin</th>
            </tr>
        </thead>
    <tbody>
    @foreach( Auth::user()->rooms as $room)

            @foreach( $room->reserved as $reservation )

                <tr>
                    <td>{{ $reservation->room->title }}</td>
                    <td>{{ $reservation->room->address->ville }}</td>
                    <td>{{ $reservation->room->address->pays }}</td>
                    <td>{{ $reservation->date_start }}</td>
                    <td>{{ $reservation->date_end }}</td>
                </tr>

            @endforeach

    @endforeach
    </tbody>
</table>
@endif


@endsection

resources/views/rooms/create.blade.php
@extends('layouts.app')

@section('title', 'Ajouter une chambre')

@section('header')
    <h1>Ajouter une chambre</h1>
@endsection

@section('content')
    @include('errors')

     <form action="{{ route('rooms.store') }}" method="POST">

         {{-- Champs de protection CSRF (obligatoire avec Laravel) --}}
         @csrf

         <!-- Titre annonce -->
         <div class="form-row">
             <div class="col-md-12 mb-3">
                 <label>Titre de votre annonce</label>
                 <input type="text" name="title" class="form-control" value="{{ old('title') }}">
             </div>
         </div>

         <!-- Taille / Prix / Couchage -->
         <div class="form-row">
             <div class="col-md-4 mb-3">
                 <label>Taille</label>
                 <div class="input-group">
                     <input type="number" step="0.5" name="size" class="form-control" value="{{ old('size') }}">
                     <div class="input-group-prepend">
                         <span class="input-group-text">m²</span>
                     </div>
                 </div>
             </div>
             <div class="col-md-4 mb-3">
                 <label>Prix pour la nuit</label>
                 <div class="input-group">
                     <input type="number" step="0.01" name="price" class="form-control" value="{{ old('price') }}">
                     <div class="input-group-prepend">
                         <span class="input-group-text">€</span>
                     </div>
                 </div>
             </div>
             <div class="col-md-4 mb-3">
                 <label>Nombre de couchages</label>
                 <input type="number" step="1" name="bedding" class="form-control" value="{{ old('bedding') }}">
             </div>
         </div>

         <!-- Num rue / Adresse complète -->
         <div class="form-row">
             <div class="col-md-3 mb-3">
                 <label>Numéro</label>
                 <input type="text" name="numero" class="form-control" value="{{ old('numero') }}">
             </div>
             <div class="col-md-9 mb-3">
                 <label>Adresse complète</label>
                 <input type="text" name="rue" class="form-control" value="{{ old('rue') }}">
             </div>
         </div>

         <!-- CP / Ville / Pays -->
         <div class="form-row">
             <div class="col-md-3 mb-3">
                 <label>Code Postal</label>
                 <input type="number" step="1" name="cp" class="form-control" value="{{ old('cp') }}">
             </div>
             <div class="col-md-6 mb-3">
                 <label>Ville</label>
                 <input type="text" name="ville" class="form-control" value="{{ old('ville') }}">
             </div>
             <div class="col-md-3 mb-3">
                 <label>Pays</label>
                 <input type="text" name="pays" class="form-control" value="{{ old('pays') }}">
             </div>
         </div>

         <!-- Description -->
         <div class="form-group">
             <label>Description</label>
             <textarea name="description" class="form-control" rows="5">{{ old('description') }}</textarea>
         </div>

         <!-- Type logement -->
         <div class="form-group">
             <label>Type de location</label>
             <select name="type_id" class="custom-select">
                 <option selected>Selectionner un type de location</option>
                 @foreach ($types as $type )
                 <option value="{{ $type->id }}">{{ $type->label }}</option>
                 @endforeach
             </select>
         </div>

         <!-- Equipements -->
         <div class="form-group">
             <label>Equipements</label>
             <br>
             @foreach ($equipments as $equipment )
             <div class="form-check form-check-inline">
                 <input name="equipments[]" class="form-check-input" type="checkbox" value="{{ $equipment->id }}">
                 <label class="form-check-label" >{{ $equipment->label }}</label>
             </div>
             @endforeach
         </div>

        <button class="btn btn-primary" type="submit">Envoyer</button>
    </form>

@endsection

resources/views/rooms/index.blade.php
@extends('layouts.app')

@section('title', 'Chambres')

@section('header')
    <h1>Toutes les chambres</h1>

@endsection

@section('content')

    <div class="card-columns">
        @foreach ($rooms as $room)
            <div class="card">
                <div class="card-body">
                    <h2 class="card-title">{{ $room->title }} </h2>
                    <hr>
                    <h3 class="card-title">{{ $room->size }} m²</h3>
                    <h3 class="card-title">{{ $room->price }}€ la nuit</h3>
                    <p class="card-text">{{ $room->bedding }} couchages</p>
                    <p class="card-text text-justify">{{ $room->description }}</p>
                <a href="{{ route('rooms.show', $room) }}" class="btn btn-primary mb-md-3">Voir la location</a>
                </div>
            </div>
        @endforeach
    </div>

@endsection

resources/views/rooms/show.blade.php
@extends('layouts.app')

@section('title', 'Chambres')

@section('header')
    <h1>Toutes les chambres</h1>
@endsection

@section('content')

    <div>

        <h2>{{ $room->title }}</h2>
        <span>Proposé par {{ $room->user->name  }}</span>
        <hr>
        <span class="h3">{{ $room->type->label }}</span>
        <br>
        <span class="h4">{{ $room->size }}m²</span> -
        <span class="h4">{{ $room->price }}€ la nuit</span>
        <p>{{ $room->description }}</p>
        <p>{{ $room->bedding }} couchages</p>

        <p>Situé au
            {{ $room->address->numero }}
            {{ $room->address->rue }} -
            {{ $room->address->cp }}
            {{ $room->address->ville }},
            {{ $room->address->pays }}
        </p>

        <p>Equipements disponibles : </p>
            <span>
                @foreach ($equips as $equip)
                    {{ $room->hasEquipment( $equip->id ) ? $equip->label : '' }}
                @endforeach
            </span>

    </div>

    <hr>

    @auth
        <div>
        <form action="{{ route('reservations.store', $room) }}" method="POST">

            {{-- Champs de protection CSRF (obligatoire avec Laravel) --}}
            @csrf

            <div class="text-center">
                <div class="h3">Reservation</div>
                du
                <input type="date"
                       name="date_start"
                       value="{{ date('Y-m-d') }}">
                au
                <input type="date"
                       name="date_end"
                       value="{{ date('Y-m-d', strtotime( '+1 week' )) }}">

                <br><br>
                <button class="btn btn-primary" type="submit">Réserver cette location</button>
            </div>
        </form>
    </div>
    @endauth
@endsection